/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"
#include "JSMediaCapabilitiesDecodingInfo.h"

#include "Document.h"
#include "JSDOMConvertBoolean.h"
#include "JSDOMGlobalObject.h"
#include "JSMediaDecodingConfiguration.h"
#include "Settings.h"
#include <JavaScriptCore/JSCInlines.h>
#include <JavaScriptCore/ObjectConstructor.h>


namespace WebCore {
using namespace JSC;

template<> MediaCapabilitiesDecodingInfo convertDictionary<MediaCapabilitiesDecodingInfo>(ExecState& state, JSValue value)
{
    VM& vm = state.vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    bool isNullOrUndefined = value.isUndefinedOrNull();
    auto* object = isNullOrUndefined ? nullptr : value.getObject();
    if (UNLIKELY(!isNullOrUndefined && !object)) {
        throwTypeError(&state, throwScope);
        return { };
    }
    MediaCapabilitiesDecodingInfo result;
    JSValue powerEfficientValue;
    if (isNullOrUndefined)
        powerEfficientValue = jsUndefined();
    else {
        powerEfficientValue = object->get(&state, Identifier::fromString(vm, "powerEfficient"));
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    if (!powerEfficientValue.isUndefined()) {
        result.powerEfficient = convert<IDLBoolean>(state, powerEfficientValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else {
        throwRequiredMemberTypeError(state, throwScope, "powerEfficient", "MediaCapabilitiesDecodingInfo", "boolean");
        return { };
    }
    JSValue smoothValue;
    if (isNullOrUndefined)
        smoothValue = jsUndefined();
    else {
        smoothValue = object->get(&state, Identifier::fromString(vm, "smooth"));
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    if (!smoothValue.isUndefined()) {
        result.smooth = convert<IDLBoolean>(state, smoothValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else {
        throwRequiredMemberTypeError(state, throwScope, "smooth", "MediaCapabilitiesDecodingInfo", "boolean");
        return { };
    }
    JSValue supportedValue;
    if (isNullOrUndefined)
        supportedValue = jsUndefined();
    else {
        supportedValue = object->get(&state, Identifier::fromString(vm, "supported"));
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    if (!supportedValue.isUndefined()) {
        result.supported = convert<IDLBoolean>(state, supportedValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else {
        throwRequiredMemberTypeError(state, throwScope, "supported", "MediaCapabilitiesDecodingInfo", "boolean");
        return { };
    }
    JSValue supportedConfigurationValue;
    if (isNullOrUndefined)
        supportedConfigurationValue = jsUndefined();
    else {
        supportedConfigurationValue = object->get(&state, Identifier::fromString(vm, "supportedConfiguration"));
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    if (!supportedConfigurationValue.isUndefined()) {
        result.supportedConfiguration = convert<IDLDictionary<MediaDecodingConfiguration>>(state, supportedConfigurationValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    return result;
}

JSC::JSObject* convertDictionaryToJS(JSC::ExecState& state, JSDOMGlobalObject& globalObject, const MediaCapabilitiesDecodingInfo& dictionary)
{
    auto& vm = state.vm();

    auto result = constructEmptyObject(&state, globalObject.objectPrototype());

    auto powerEfficientValue = toJS<IDLBoolean>(dictionary.powerEfficient);
    result->putDirect(vm, JSC::Identifier::fromString(vm, "powerEfficient"), powerEfficientValue);
    auto smoothValue = toJS<IDLBoolean>(dictionary.smooth);
    result->putDirect(vm, JSC::Identifier::fromString(vm, "smooth"), smoothValue);
    auto supportedValue = toJS<IDLBoolean>(dictionary.supported);
    result->putDirect(vm, JSC::Identifier::fromString(vm, "supported"), supportedValue);
    if (downcast<Document>(jsCast<JSDOMGlobalObject*>(&globalObject)->scriptExecutionContext())->settings().mediaCapabilitiesExtensionsEnabled()) {
        if (!IDLDictionary<MediaDecodingConfiguration>::isNullValue(dictionary.supportedConfiguration)) {
            auto supportedConfigurationValue = toJS<IDLDictionary<MediaDecodingConfiguration>>(state, globalObject, IDLDictionary<MediaDecodingConfiguration>::extractValueFromNullable(dictionary.supportedConfiguration));
            result->putDirect(vm, JSC::Identifier::fromString(vm, "supportedConfiguration"), supportedConfigurationValue);
        }
    }
    return result;
}

} // namespace WebCore
