/*
* THIS FILE WAS AUTOMATICALLY GENERATED, DO NOT EDIT.
*
* Copyright (C) 2018 Apple Inc. All rights reserved.
*
* Redistribution and use in source and binary forms, with or without
* modification, are permitted provided that the following conditions
* are met:
* 1. Redistributions of source code must retain the above copyright
*    notice, this list of conditions and the following disclaimer.
* 2. Redistributions in binary form must reproduce the above copyright
*    notice, this list of conditions and the following disclaimer in the
*    documentation and/or other materials provided with the distribution.
*
* THIS SOFTWARE IS PROVIDED BY APPLE INC. AND ITS CONTRIBUTORS ``AS IS''
* AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
* THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
* PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL APPLE INC. OR ITS CONTRIBUTORS
* BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
* CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
* SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
* INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
* CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
* ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
* THE POSSIBILITY OF SUCH DAMAGE.
*/

#include "config.h"
#include "WebPreferences.h"

#include "WebPreferencesKeys.h"

namespace WebKit {

void WebPreferences::setAllowViewportShrinkToFitContent(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::allowViewportShrinkToFitContentKey(), value))
        return;
    updateBoolValueForInternalDebugFeatureKey(WebPreferencesKey::allowViewportShrinkToFitContentKey(), value);
}

bool WebPreferences::allowViewportShrinkToFitContent() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::allowViewportShrinkToFitContentKey());
}

void WebPreferences::setApplePayRemoteUIEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::applePayRemoteUIEnabledKey(), value))
        return;
    updateBoolValueForInternalDebugFeatureKey(WebPreferencesKey::applePayRemoteUIEnabledKey(), value);
}

bool WebPreferences::applePayRemoteUIEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::applePayRemoteUIEnabledKey());
}

void WebPreferences::setAriaReflectionEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::ariaReflectionEnabledKey(), value))
        return;
    updateBoolValueForInternalDebugFeatureKey(WebPreferencesKey::ariaReflectionEnabledKey(), value);
}

bool WebPreferences::ariaReflectionEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::ariaReflectionEnabledKey());
}

void WebPreferences::setAsyncFrameScrollingEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::asyncFrameScrollingEnabledKey(), value))
        return;
    updateBoolValueForInternalDebugFeatureKey(WebPreferencesKey::asyncFrameScrollingEnabledKey(), value);
}

bool WebPreferences::asyncFrameScrollingEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::asyncFrameScrollingEnabledKey());
}

void WebPreferences::setAsyncOverflowScrollingEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::asyncOverflowScrollingEnabledKey(), value))
        return;
    updateBoolValueForInternalDebugFeatureKey(WebPreferencesKey::asyncOverflowScrollingEnabledKey(), value);
}

bool WebPreferences::asyncOverflowScrollingEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::asyncOverflowScrollingEnabledKey());
}

void WebPreferences::setBlockingOfSmallPluginsEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::blockingOfSmallPluginsEnabledKey(), value))
        return;
    updateBoolValueForInternalDebugFeatureKey(WebPreferencesKey::blockingOfSmallPluginsEnabledKey(), value);
}

bool WebPreferences::blockingOfSmallPluginsEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::blockingOfSmallPluginsEnabledKey());
}

void WebPreferences::setCSSLogicalEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::cssLogicalEnabledKey(), value))
        return;
    updateBoolValueForInternalDebugFeatureKey(WebPreferencesKey::cssLogicalEnabledKey(), value);
}

bool WebPreferences::cssLogicalEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::cssLogicalEnabledKey());
}

void WebPreferences::setCSSOMViewScrollingAPIEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::cssOMViewScrollingAPIEnabledKey(), value))
        return;
    updateBoolValueForInternalDebugFeatureKey(WebPreferencesKey::cssOMViewScrollingAPIEnabledKey(), value);
}

bool WebPreferences::cssOMViewScrollingAPIEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::cssOMViewScrollingAPIEnabledKey());
}

void WebPreferences::setCaptureAudioInUIProcessEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::captureAudioInUIProcessEnabledKey(), value))
        return;
    updateBoolValueForInternalDebugFeatureKey(WebPreferencesKey::captureAudioInUIProcessEnabledKey(), value);
}

bool WebPreferences::captureAudioInUIProcessEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::captureAudioInUIProcessEnabledKey());
}

void WebPreferences::setCaptureVideoInUIProcessEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::captureVideoInUIProcessEnabledKey(), value))
        return;
    updateBoolValueForInternalDebugFeatureKey(WebPreferencesKey::captureVideoInUIProcessEnabledKey(), value);
}

bool WebPreferences::captureVideoInUIProcessEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::captureVideoInUIProcessEnabledKey());
}

void WebPreferences::setDOMPasteAccessRequestsEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::domPasteAccessRequestsEnabledKey(), value))
        return;
    updateBoolValueForInternalDebugFeatureKey(WebPreferencesKey::domPasteAccessRequestsEnabledKey(), value);
}

bool WebPreferences::domPasteAccessRequestsEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::domPasteAccessRequestsEnabledKey());
}

void WebPreferences::setDataListElementEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::dataListElementEnabledKey(), value))
        return;
    updateBoolValueForInternalDebugFeatureKey(WebPreferencesKey::dataListElementEnabledKey(), value);
}

bool WebPreferences::dataListElementEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::dataListElementEnabledKey());
}

void WebPreferences::setExperimentalPlugInSandboxProfilesEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::experimentalPlugInSandboxProfilesEnabledKey(), value))
        return;
    updateBoolValueForInternalDebugFeatureKey(WebPreferencesKey::experimentalPlugInSandboxProfilesEnabledKey(), value);
}

bool WebPreferences::experimentalPlugInSandboxProfilesEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::experimentalPlugInSandboxProfilesEnabledKey());
}

void WebPreferences::setFastClicksEverywhere(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::fastClicksEverywhereKey(), value))
        return;
    updateBoolValueForInternalDebugFeatureKey(WebPreferencesKey::fastClicksEverywhereKey(), value);
}

bool WebPreferences::fastClicksEverywhere() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::fastClicksEverywhereKey());
}

void WebPreferences::setFasterClicksEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::fasterClicksEnabledKey(), value))
        return;
    updateBoolValueForInternalDebugFeatureKey(WebPreferencesKey::fasterClicksEnabledKey(), value);
}

bool WebPreferences::fasterClicksEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::fasterClicksEnabledKey());
}

void WebPreferences::setFrameFlatteningEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::frameFlatteningEnabledKey(), value))
        return;
    updateBoolValueForInternalDebugFeatureKey(WebPreferencesKey::frameFlatteningEnabledKey(), value);
}

bool WebPreferences::frameFlatteningEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::frameFlatteningEnabledKey());
}

void WebPreferences::setFullScreenEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::fullScreenEnabledKey(), value))
        return;
    updateBoolValueForInternalDebugFeatureKey(WebPreferencesKey::fullScreenEnabledKey(), value);
}

bool WebPreferences::fullScreenEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::fullScreenEnabledKey());
}

void WebPreferences::setInputTypeColorEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::inputTypeColorEnabledKey(), value))
        return;
    updateBoolValueForInternalDebugFeatureKey(WebPreferencesKey::inputTypeColorEnabledKey(), value);
}

bool WebPreferences::inputTypeColorEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::inputTypeColorEnabledKey());
}

void WebPreferences::setIsITPDatabaseEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::isITPDatabaseEnabledKey(), value))
        return;
    updateBoolValueForInternalDebugFeatureKey(WebPreferencesKey::isITPDatabaseEnabledKey(), value);
}

bool WebPreferences::isITPDatabaseEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::isITPDatabaseEnabledKey());
}

void WebPreferences::setIsITPSessionSwitchingEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::isITPSessionSwitchingEnabledKey(), value))
        return;
    updateBoolValueForInternalDebugFeatureKey(WebPreferencesKey::isITPSessionSwitchingEnabledKey(), value);
}

bool WebPreferences::isITPSessionSwitchingEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::isITPSessionSwitchingEnabledKey());
}

void WebPreferences::setIsNSURLSessionWebSocketEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::isNSURLSessionWebSocketEnabledKey(), value))
        return;
    updateBoolValueForInternalDebugFeatureKey(WebPreferencesKey::isNSURLSessionWebSocketEnabledKey(), value);
}

bool WebPreferences::isNSURLSessionWebSocketEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::isNSURLSessionWebSocketEnabledKey());
}

void WebPreferences::setKeygenElementEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::keygenElementEnabledKey(), value))
        return;
    updateBoolValueForInternalDebugFeatureKey(WebPreferencesKey::keygenElementEnabledKey(), value);
}

bool WebPreferences::keygenElementEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::keygenElementEnabledKey());
}

void WebPreferences::setLayoutFormattingContextEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::layoutFormattingContextEnabledKey(), value))
        return;
    updateBoolValueForInternalDebugFeatureKey(WebPreferencesKey::layoutFormattingContextEnabledKey(), value);
}

bool WebPreferences::layoutFormattingContextEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::layoutFormattingContextEnabledKey());
}

void WebPreferences::setLegacyOverflowScrollingTouchEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::legacyOverflowScrollingTouchEnabledKey(), value))
        return;
    updateBoolValueForInternalDebugFeatureKey(WebPreferencesKey::legacyOverflowScrollingTouchEnabledKey(), value);
}

bool WebPreferences::legacyOverflowScrollingTouchEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::legacyOverflowScrollingTouchEnabledKey());
}

void WebPreferences::setMouseEventsSimulationEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::mouseEventsSimulationEnabledKey(), value))
        return;
    updateBoolValueForInternalDebugFeatureKey(WebPreferencesKey::mouseEventsSimulationEnabledKey(), value);
}

bool WebPreferences::mouseEventsSimulationEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::mouseEventsSimulationEnabledKey());
}

void WebPreferences::setRestrictedHTTPResponseAccess(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::restrictedHTTPResponseAccessKey(), value))
        return;
    updateBoolValueForInternalDebugFeatureKey(WebPreferencesKey::restrictedHTTPResponseAccessKey(), value);
}

bool WebPreferences::restrictedHTTPResponseAccess() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::restrictedHTTPResponseAccessKey());
}

void WebPreferences::setSecureContextChecksEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::secureContextChecksEnabledKey(), value))
        return;
    updateBoolValueForInternalDebugFeatureKey(WebPreferencesKey::secureContextChecksEnabledKey(), value);
}

bool WebPreferences::secureContextChecksEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::secureContextChecksEnabledKey());
}

void WebPreferences::setSelectionAcrossShadowBoundariesEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::selectionAcrossShadowBoundariesEnabledKey(), value))
        return;
    updateBoolValueForInternalDebugFeatureKey(WebPreferencesKey::selectionAcrossShadowBoundariesEnabledKey(), value);
}

bool WebPreferences::selectionAcrossShadowBoundariesEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::selectionAcrossShadowBoundariesEnabledKey());
}

void WebPreferences::setServiceWorkersEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::serviceWorkersEnabledKey(), value))
        return;
    updateBoolValueForInternalDebugFeatureKey(WebPreferencesKey::serviceWorkersEnabledKey(), value);
}

bool WebPreferences::serviceWorkersEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::serviceWorkersEnabledKey());
}

void WebPreferences::setTextAutosizingUsesIdempotentMode(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::textAutosizingUsesIdempotentModeKey(), value))
        return;
    updateBoolValueForInternalDebugFeatureKey(WebPreferencesKey::textAutosizingUsesIdempotentModeKey(), value);
}

bool WebPreferences::textAutosizingUsesIdempotentMode() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::textAutosizingUsesIdempotentModeKey());
}

void WebPreferences::setUndoManagerAPIEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::undoManagerAPIEnabledKey(), value))
        return;
    updateBoolValueForInternalDebugFeatureKey(WebPreferencesKey::undoManagerAPIEnabledKey(), value);
}

bool WebPreferences::undoManagerAPIEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::undoManagerAPIEnabledKey());
}

void WebPreferences::setWebAPIStatisticsEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::webAPIStatisticsEnabledKey(), value))
        return;
    updateBoolValueForInternalDebugFeatureKey(WebPreferencesKey::webAPIStatisticsEnabledKey(), value);
}

bool WebPreferences::webAPIStatisticsEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::webAPIStatisticsEnabledKey());
}

void WebPreferences::setWebGLCompressedTextureASTCSupportEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::webGLCompressedTextureASTCSupportEnabledKey(), value))
        return;
    updateBoolValueForInternalDebugFeatureKey(WebPreferencesKey::webGLCompressedTextureASTCSupportEnabledKey(), value);
}

bool WebPreferences::webGLCompressedTextureASTCSupportEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::webGLCompressedTextureASTCSupportEnabledKey());
}

void WebPreferences::setWebRTCH264SimulcastEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::webRTCH264SimulcastEnabledKey(), value))
        return;
    updateBoolValueForInternalDebugFeatureKey(WebPreferencesKey::webRTCH264SimulcastEnabledKey(), value);
}

bool WebPreferences::webRTCH264SimulcastEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::webRTCH264SimulcastEnabledKey());
}

void WebPreferences::setWebRTCUnifiedPlanEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::webRTCUnifiedPlanEnabledKey(), value))
        return;
    updateBoolValueForInternalDebugFeatureKey(WebPreferencesKey::webRTCUnifiedPlanEnabledKey(), value);
}

bool WebPreferences::webRTCUnifiedPlanEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::webRTCUnifiedPlanEnabledKey());
}

void WebPreferences::setWebRTCVP8CodecEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::webRTCVP8CodecEnabledKey(), value))
        return;
    updateBoolValueForInternalDebugFeatureKey(WebPreferencesKey::webRTCVP8CodecEnabledKey(), value);
}

bool WebPreferences::webRTCVP8CodecEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::webRTCVP8CodecEnabledKey());
}

const Vector<RefPtr<API::Object>>& WebPreferences::internalDebugFeatures()
{
    static NeverDestroyed<Vector<RefPtr<API::Object>>> features(std::initializer_list<RefPtr<API::Object>> {
#if PLATFORM(IOS_FAMILY)
        API::InternalDebugFeature::create("Allow Viewport Shrink to Fit Content", "AllowViewportShrinkToFitContent", "Allow the viewport shrink to fit content heuristic when appropriate", true, false),
#endif
#if ENABLE(APPLE_PAY_REMOTE_UI)
        API::InternalDebugFeature::create("Apple Pay Remote UI", "ApplePayRemoteUIEnabled", "Enable Apple Pay Remote UI", true, false),
#endif
        API::InternalDebugFeature::create("ARIA Reflection", "AriaReflectionEnabled", "ARIA Reflection support", true, false),
        API::InternalDebugFeature::create("Async Frame Scrolling", "AsyncFrameScrollingEnabled", "Perform frame scrolling off the main thread", DEFAULT_ASYNC_FRAME_SCROLLING_ENABLED, false),
        API::InternalDebugFeature::create("Async Overflow Scrolling", "AsyncOverflowScrollingEnabled", "Perform overflow scrolling off the main thread", DEFAULT_ASYNC_OVERFLOW_SCROLLING_ENABLED, false),
        API::InternalDebugFeature::create("Block small plugins", "BlockingOfSmallPluginsEnabled", "Stop plugins smaller than a certain threshold from loading.", true, false),
        API::InternalDebugFeature::create("CSS Logical Properties and Values", "CSSLogicalEnabled", "Enable CSS Logical Properties and Values", false, false),
        API::InternalDebugFeature::create("CSSOM View Scrolling API", "CSSOMViewScrollingAPIEnabled", "Implement standard behavior for scrollLeft, scrollTop, scrollWidth, scrollHeight, scrollTo, scrollBy and scrollingElement.", defaultCSSOMViewScrollingAPIEnabled(), false),
#if ENABLE(MEDIA_STREAM)
        API::InternalDebugFeature::create("Capture audio in UIProcess", "CaptureAudioInUIProcessEnabled", "Enable audio capture in UIProcess", DEFAULT_CAPTURE_AUDIO_IN_UIPROCESS, false),
#endif
#if ENABLE(MEDIA_STREAM)
        API::InternalDebugFeature::create("Capture video in UIProcess", "CaptureVideoInUIProcessEnabled", "Enable video capture in UIProcess", false, false),
#endif
        API::InternalDebugFeature::create("DOM Paste Access Requests", "DOMPasteAccessRequestsEnabled", "Enable DOM Paste Access Requests", DEFAULT_DOM_PASTE_ACCESS_REQUESTS_ENABLED, false),
#if ENABLE(DATALIST_ELEMENT)
        API::InternalDebugFeature::create("DataList Element", "DataListElementEnabled", "Enable datalist elements", DEFAULT_DATALIST_ELEMENT_ENABLED, false),
#endif
        API::InternalDebugFeature::create("Sandbox Plug-Ins", "ExperimentalPlugInSandboxProfilesEnabled", "Enable Plug-In sandboxing", false, false),
#if PLATFORM(IOS_FAMILY)
        API::InternalDebugFeature::create("Fast clicks everywhere", "FastClicksEverywhere", "Force fast clicks on all pages", DEFAULT_FAST_CLICKS_EVERYWHERE, false),
#endif
#if PLATFORM(IOS_FAMILY)
        API::InternalDebugFeature::create("Faster clicks", "FasterClicksEnabled", "Support faster clicks on zoomable pages", true, false),
#endif
        API::InternalDebugFeature::create("Frame flattening", "FrameFlatteningEnabled", "Enable frame flattening, which adjusts the height of an iframe to fit its contents", DEFAULT_FRAME_FLATTENING, false),
#if ENABLE(FULLSCREEN_API)
        API::InternalDebugFeature::create("Fullscreen API", "FullScreenEnabled", "Fullscreen API", false, EXPERIMENTAL_FULLSCREEN_API_HIDDEN),
#endif
#if ENABLE(INPUT_TYPE_COLOR)
        API::InternalDebugFeature::create("Color Inputs", "InputTypeColorEnabled", "Enable input elements of type color", DEFAULT_INPUT_TYPE_COLOR_ENABLED, false),
#endif
        API::InternalDebugFeature::create("ITP Database Backend", "IsITPDatabaseEnabled", "Enable Intelligent Tracking Prevention Database Backend", false, false),
        API::InternalDebugFeature::create("ITP Session Switching", "IsITPSessionSwitchingEnabled", "Enable session switching for domains classified by ITP", true, false),
#if HAVE(NSURLSESSION_WEBSOCKET)
        API::InternalDebugFeature::create("NSURLSession WebSocket", "IsNSURLSessionWebSocketEnabled", "Use NSURLSession WebSocket API", false, false),
#endif
        API::InternalDebugFeature::create("HTMLKeygenElement", "KeygenElementEnabled", "Enables the deprecated and disabled-by-default HTML keygen element.", false, false),
#if ENABLE(LAYOUT_FORMATTING_CONTEXT)
        API::InternalDebugFeature::create("Next-gen layout", "LayoutFormattingContextEnabled", "Enable next-gen layout", false, false),
#endif
#if ENABLE(OVERFLOW_SCROLLING_TOUCH)
        API::InternalDebugFeature::create("Legacy -webkit-overflow-scrolling property", "LegacyOverflowScrollingTouchEnabled", "Support the legacy -webkit-overflow-scrolling CSS property", true, false),
#endif
#if ENABLE(TOUCH_EVENTS)
        API::InternalDebugFeature::create("Mouse events simulation", "MouseEventsSimulationEnabled", "Enable mouse events dispatch along with touch events on iOS", false, false),
#endif
        API::InternalDebugFeature::create("Filter HTTP Response for WebProcesses", "RestrictedHTTPResponseAccess", "Enable HTTP Response filtering for WebProcesses", true, false),
        API::InternalDebugFeature::create("Secure Context Checks", "SecureContextChecksEnabled", "Allow access to HTTPS-only Web APIs over HTTP", true, false),
        API::InternalDebugFeature::create("Selection across shadow DOM", "SelectionAcrossShadowBoundariesEnabled", "Allow user-initiated selection across shadow DOM boundaries", true, false),
#if ENABLE(SERVICE_WORKER)
        API::InternalDebugFeature::create("Service Workers", "ServiceWorkersEnabled", "Enable Service Workers", DEFAULT_SERVICE_WORKERS_ENABLED, false),
#endif
#if ENABLE(TEXT_AUTOSIZING)
        API::InternalDebugFeature::create("Idempotent Text Autosizing", "TextAutosizingUsesIdempotentMode", "Use idempotent text autosizing mode", defaultTextAutosizingUsesIdempotentMode(), false),
#endif
        API::InternalDebugFeature::create("UndoManager DOM API", "UndoManagerAPIEnabled", "Enable the UndoManager DOM API", false, false),
        API::InternalDebugFeature::create("Web API Statistics", "WebAPIStatisticsEnabled", "Enable Web API Statistics", false, false),
        API::InternalDebugFeature::create("ASTC Texture Support", "WebGLCompressedTextureASTCSupportEnabled", "Support for ASTC compressed texture formats in WebGL", false, false),
#if ENABLE(WEB_RTC)
        API::InternalDebugFeature::create("WebRTC H264 Simulcast", "WebRTCH264SimulcastEnabled", "Enable WebRTC H264 Simulcast", true, false),
#endif
#if ENABLE(WEB_RTC)
        API::InternalDebugFeature::create("WebRTC Unified Plan", "WebRTCUnifiedPlanEnabled", "Use WebRTC Unified Plan", true, false),
#endif
#if ENABLE(WEB_RTC)
        API::InternalDebugFeature::create("WebRTC VP8 codec", "WebRTCVP8CodecEnabled", "Enable WebRTC VP8 codec", true, false),
#endif
    });

    return features;
}

bool WebPreferences::isFeatureEnabled(const API::InternalDebugFeature& feature) const
{
    struct FeatureGetterMapping {
        const char* name;
        bool (WebPreferences::*function) () const;
    };

    static FeatureGetterMapping getters[] = {
#if PLATFORM(IOS_FAMILY)
        { "AllowViewportShrinkToFitContent", &WebPreferences::allowViewportShrinkToFitContent },
#endif
#if ENABLE(APPLE_PAY_REMOTE_UI)
        { "ApplePayRemoteUIEnabled", &WebPreferences::applePayRemoteUIEnabled },
#endif
        { "AriaReflectionEnabled", &WebPreferences::ariaReflectionEnabled },
        { "AsyncFrameScrollingEnabled", &WebPreferences::asyncFrameScrollingEnabled },
        { "AsyncOverflowScrollingEnabled", &WebPreferences::asyncOverflowScrollingEnabled },
        { "BlockingOfSmallPluginsEnabled", &WebPreferences::blockingOfSmallPluginsEnabled },
        { "CSSLogicalEnabled", &WebPreferences::cssLogicalEnabled },
        { "CSSOMViewScrollingAPIEnabled", &WebPreferences::cssOMViewScrollingAPIEnabled },
#if ENABLE(MEDIA_STREAM)
        { "CaptureAudioInUIProcessEnabled", &WebPreferences::captureAudioInUIProcessEnabled },
#endif
#if ENABLE(MEDIA_STREAM)
        { "CaptureVideoInUIProcessEnabled", &WebPreferences::captureVideoInUIProcessEnabled },
#endif
        { "DOMPasteAccessRequestsEnabled", &WebPreferences::domPasteAccessRequestsEnabled },
#if ENABLE(DATALIST_ELEMENT)
        { "DataListElementEnabled", &WebPreferences::dataListElementEnabled },
#endif
        { "ExperimentalPlugInSandboxProfilesEnabled", &WebPreferences::experimentalPlugInSandboxProfilesEnabled },
#if PLATFORM(IOS_FAMILY)
        { "FastClicksEverywhere", &WebPreferences::fastClicksEverywhere },
#endif
#if PLATFORM(IOS_FAMILY)
        { "FasterClicksEnabled", &WebPreferences::fasterClicksEnabled },
#endif
        { "FrameFlatteningEnabled", &WebPreferences::frameFlatteningEnabled },
#if ENABLE(FULLSCREEN_API)
        { "FullScreenEnabled", &WebPreferences::fullScreenEnabled },
#endif
#if ENABLE(INPUT_TYPE_COLOR)
        { "InputTypeColorEnabled", &WebPreferences::inputTypeColorEnabled },
#endif
        { "IsITPDatabaseEnabled", &WebPreferences::isITPDatabaseEnabled },
        { "IsITPSessionSwitchingEnabled", &WebPreferences::isITPSessionSwitchingEnabled },
#if HAVE(NSURLSESSION_WEBSOCKET)
        { "IsNSURLSessionWebSocketEnabled", &WebPreferences::isNSURLSessionWebSocketEnabled },
#endif
        { "KeygenElementEnabled", &WebPreferences::keygenElementEnabled },
#if ENABLE(LAYOUT_FORMATTING_CONTEXT)
        { "LayoutFormattingContextEnabled", &WebPreferences::layoutFormattingContextEnabled },
#endif
#if ENABLE(OVERFLOW_SCROLLING_TOUCH)
        { "LegacyOverflowScrollingTouchEnabled", &WebPreferences::legacyOverflowScrollingTouchEnabled },
#endif
#if ENABLE(TOUCH_EVENTS)
        { "MouseEventsSimulationEnabled", &WebPreferences::mouseEventsSimulationEnabled },
#endif
        { "RestrictedHTTPResponseAccess", &WebPreferences::restrictedHTTPResponseAccess },
        { "SecureContextChecksEnabled", &WebPreferences::secureContextChecksEnabled },
        { "SelectionAcrossShadowBoundariesEnabled", &WebPreferences::selectionAcrossShadowBoundariesEnabled },
#if ENABLE(SERVICE_WORKER)
        { "ServiceWorkersEnabled", &WebPreferences::serviceWorkersEnabled },
#endif
#if ENABLE(TEXT_AUTOSIZING)
        { "TextAutosizingUsesIdempotentMode", &WebPreferences::textAutosizingUsesIdempotentMode },
#endif
        { "UndoManagerAPIEnabled", &WebPreferences::undoManagerAPIEnabled },
        { "WebAPIStatisticsEnabled", &WebPreferences::webAPIStatisticsEnabled },
        { "WebGLCompressedTextureASTCSupportEnabled", &WebPreferences::webGLCompressedTextureASTCSupportEnabled },
#if ENABLE(WEB_RTC)
        { "WebRTCH264SimulcastEnabled", &WebPreferences::webRTCH264SimulcastEnabled },
#endif
#if ENABLE(WEB_RTC)
        { "WebRTCUnifiedPlanEnabled", &WebPreferences::webRTCUnifiedPlanEnabled },
#endif
#if ENABLE(WEB_RTC)
        { "WebRTCVP8CodecEnabled", &WebPreferences::webRTCVP8CodecEnabled },
#endif
    };

    const String& key = feature.key();

    for (auto& getter : getters) {
        if (key == getter.name)
            return (this->*getter.function)();
    }

    return false;
}

void WebPreferences::setFeatureEnabled(const API::InternalDebugFeature& feature, bool value)
{
    setInternalDebugFeatureEnabledForKey(feature.key(), value);
}

void WebPreferences::setInternalDebugFeatureEnabledForKey(const String& key, bool value)
{
    struct FeatureSetterMapping {
        const char* name;
        void (WebPreferences::*function) (const bool&);
    };

    static FeatureSetterMapping setters[] = {
#if PLATFORM(IOS_FAMILY)
        { "AllowViewportShrinkToFitContent", &WebPreferences::setAllowViewportShrinkToFitContent },
#endif
#if ENABLE(APPLE_PAY_REMOTE_UI)
        { "ApplePayRemoteUIEnabled", &WebPreferences::setApplePayRemoteUIEnabled },
#endif
        { "AriaReflectionEnabled", &WebPreferences::setAriaReflectionEnabled },
        { "AsyncFrameScrollingEnabled", &WebPreferences::setAsyncFrameScrollingEnabled },
        { "AsyncOverflowScrollingEnabled", &WebPreferences::setAsyncOverflowScrollingEnabled },
        { "BlockingOfSmallPluginsEnabled", &WebPreferences::setBlockingOfSmallPluginsEnabled },
        { "CSSLogicalEnabled", &WebPreferences::setCSSLogicalEnabled },
        { "CSSOMViewScrollingAPIEnabled", &WebPreferences::setCSSOMViewScrollingAPIEnabled },
#if ENABLE(MEDIA_STREAM)
        { "CaptureAudioInUIProcessEnabled", &WebPreferences::setCaptureAudioInUIProcessEnabled },
#endif
#if ENABLE(MEDIA_STREAM)
        { "CaptureVideoInUIProcessEnabled", &WebPreferences::setCaptureVideoInUIProcessEnabled },
#endif
        { "DOMPasteAccessRequestsEnabled", &WebPreferences::setDOMPasteAccessRequestsEnabled },
#if ENABLE(DATALIST_ELEMENT)
        { "DataListElementEnabled", &WebPreferences::setDataListElementEnabled },
#endif
        { "ExperimentalPlugInSandboxProfilesEnabled", &WebPreferences::setExperimentalPlugInSandboxProfilesEnabled },
#if PLATFORM(IOS_FAMILY)
        { "FastClicksEverywhere", &WebPreferences::setFastClicksEverywhere },
#endif
#if PLATFORM(IOS_FAMILY)
        { "FasterClicksEnabled", &WebPreferences::setFasterClicksEnabled },
#endif
        { "FrameFlatteningEnabled", &WebPreferences::setFrameFlatteningEnabled },
#if ENABLE(FULLSCREEN_API)
        { "FullScreenEnabled", &WebPreferences::setFullScreenEnabled },
#endif
#if ENABLE(INPUT_TYPE_COLOR)
        { "InputTypeColorEnabled", &WebPreferences::setInputTypeColorEnabled },
#endif
        { "IsITPDatabaseEnabled", &WebPreferences::setIsITPDatabaseEnabled },
        { "IsITPSessionSwitchingEnabled", &WebPreferences::setIsITPSessionSwitchingEnabled },
#if HAVE(NSURLSESSION_WEBSOCKET)
        { "IsNSURLSessionWebSocketEnabled", &WebPreferences::setIsNSURLSessionWebSocketEnabled },
#endif
        { "KeygenElementEnabled", &WebPreferences::setKeygenElementEnabled },
#if ENABLE(LAYOUT_FORMATTING_CONTEXT)
        { "LayoutFormattingContextEnabled", &WebPreferences::setLayoutFormattingContextEnabled },
#endif
#if ENABLE(OVERFLOW_SCROLLING_TOUCH)
        { "LegacyOverflowScrollingTouchEnabled", &WebPreferences::setLegacyOverflowScrollingTouchEnabled },
#endif
#if ENABLE(TOUCH_EVENTS)
        { "MouseEventsSimulationEnabled", &WebPreferences::setMouseEventsSimulationEnabled },
#endif
        { "RestrictedHTTPResponseAccess", &WebPreferences::setRestrictedHTTPResponseAccess },
        { "SecureContextChecksEnabled", &WebPreferences::setSecureContextChecksEnabled },
        { "SelectionAcrossShadowBoundariesEnabled", &WebPreferences::setSelectionAcrossShadowBoundariesEnabled },
#if ENABLE(SERVICE_WORKER)
        { "ServiceWorkersEnabled", &WebPreferences::setServiceWorkersEnabled },
#endif
#if ENABLE(TEXT_AUTOSIZING)
        { "TextAutosizingUsesIdempotentMode", &WebPreferences::setTextAutosizingUsesIdempotentMode },
#endif
        { "UndoManagerAPIEnabled", &WebPreferences::setUndoManagerAPIEnabled },
        { "WebAPIStatisticsEnabled", &WebPreferences::setWebAPIStatisticsEnabled },
        { "WebGLCompressedTextureASTCSupportEnabled", &WebPreferences::setWebGLCompressedTextureASTCSupportEnabled },
#if ENABLE(WEB_RTC)
        { "WebRTCH264SimulcastEnabled", &WebPreferences::setWebRTCH264SimulcastEnabled },
#endif
#if ENABLE(WEB_RTC)
        { "WebRTCUnifiedPlanEnabled", &WebPreferences::setWebRTCUnifiedPlanEnabled },
#endif
#if ENABLE(WEB_RTC)
        { "WebRTCVP8CodecEnabled", &WebPreferences::setWebRTCVP8CodecEnabled },
#endif
    };

    for (auto& setter : setters) {
        if (key == setter.name) {
            (this->*setter.function)(value);
            return;
        }
    }
}

void WebPreferences::resetAllInternalDebugFeatures()
{
#if PLATFORM(IOS_FAMILY)
    setAllowViewportShrinkToFitContent(true);
#endif
#if ENABLE(APPLE_PAY_REMOTE_UI)
    setApplePayRemoteUIEnabled(true);
#endif
    setAriaReflectionEnabled(true);
    setAsyncFrameScrollingEnabled(DEFAULT_ASYNC_FRAME_SCROLLING_ENABLED);
    setAsyncOverflowScrollingEnabled(DEFAULT_ASYNC_OVERFLOW_SCROLLING_ENABLED);
    setBlockingOfSmallPluginsEnabled(true);
    setCSSLogicalEnabled(false);
    setCSSOMViewScrollingAPIEnabled(defaultCSSOMViewScrollingAPIEnabled());
#if ENABLE(MEDIA_STREAM)
    setCaptureAudioInUIProcessEnabled(DEFAULT_CAPTURE_AUDIO_IN_UIPROCESS);
#endif
#if ENABLE(MEDIA_STREAM)
    setCaptureVideoInUIProcessEnabled(false);
#endif
    setDOMPasteAccessRequestsEnabled(DEFAULT_DOM_PASTE_ACCESS_REQUESTS_ENABLED);
#if ENABLE(DATALIST_ELEMENT)
    setDataListElementEnabled(DEFAULT_DATALIST_ELEMENT_ENABLED);
#endif
    setExperimentalPlugInSandboxProfilesEnabled(false);
#if PLATFORM(IOS_FAMILY)
    setFastClicksEverywhere(DEFAULT_FAST_CLICKS_EVERYWHERE);
#endif
#if PLATFORM(IOS_FAMILY)
    setFasterClicksEnabled(true);
#endif
    setFrameFlatteningEnabled(DEFAULT_FRAME_FLATTENING);
#if ENABLE(FULLSCREEN_API)
    setFullScreenEnabled(false);
#endif
#if ENABLE(INPUT_TYPE_COLOR)
    setInputTypeColorEnabled(DEFAULT_INPUT_TYPE_COLOR_ENABLED);
#endif
    setIsITPDatabaseEnabled(false);
    setIsITPSessionSwitchingEnabled(true);
#if HAVE(NSURLSESSION_WEBSOCKET)
    setIsNSURLSessionWebSocketEnabled(false);
#endif
    setKeygenElementEnabled(false);
#if ENABLE(LAYOUT_FORMATTING_CONTEXT)
    setLayoutFormattingContextEnabled(false);
#endif
#if ENABLE(OVERFLOW_SCROLLING_TOUCH)
    setLegacyOverflowScrollingTouchEnabled(true);
#endif
#if ENABLE(TOUCH_EVENTS)
    setMouseEventsSimulationEnabled(false);
#endif
    setRestrictedHTTPResponseAccess(true);
    setSecureContextChecksEnabled(true);
    setSelectionAcrossShadowBoundariesEnabled(true);
#if ENABLE(SERVICE_WORKER)
    setServiceWorkersEnabled(DEFAULT_SERVICE_WORKERS_ENABLED);
#endif
#if ENABLE(TEXT_AUTOSIZING)
    setTextAutosizingUsesIdempotentMode(defaultTextAutosizingUsesIdempotentMode());
#endif
    setUndoManagerAPIEnabled(false);
    setWebAPIStatisticsEnabled(false);
    setWebGLCompressedTextureASTCSupportEnabled(false);
#if ENABLE(WEB_RTC)
    setWebRTCH264SimulcastEnabled(true);
#endif
#if ENABLE(WEB_RTC)
    setWebRTCUnifiedPlanEnabled(true);
#endif
#if ENABLE(WEB_RTC)
    setWebRTCVP8CodecEnabled(true);
#endif
}

}
